﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Core.Layers;
using Infragistics.UltraChart.Core.Primitives;
using System.Diagnostics;

namespace UltraChartBubbleChartLegend
{
    public partial class Form1 : Form
    {

        private Infragistics.Win.UltraWinToolTip.UltraToolTipInfo tt;
        private DataTable dt;

        public Form1()
        {
            InitializeComponent();

            tt = new Infragistics.Win.UltraWinToolTip.UltraToolTipInfo("", ultraToolTipManager1.ToolTipImage, "", Infragistics.Win.DefaultableBoolean.True);

            // DataSourse
            dt = new DataTable();
            dt.Columns.Add("ItemLabel", typeof(string));
            dt.Columns.Add("ActualDate", typeof(DateTime));
            dt.Columns.Add("DateAsOADateX", typeof(double));
            dt.Columns.Add("PriceY", typeof(double));
            dt.Columns.Add("SalesR", typeof(double));

            DateTime StartDate = new DateTime(2012, 1, 31);

            dt.Rows.Add("Retailer", StartDate, ConvertDateToNumericOADate(StartDate), 8.058, 261260);
            dt.Rows.Add("Retailer", StartDate.AddMonths(1), ConvertDateToNumericOADate(StartDate.AddMonths(1)), 7.96, 112400);
            dt.Rows.Add("Retailer", StartDate.AddMonths(2), ConvertDateToNumericOADate(StartDate.AddMonths(2)), 8.01, 57570);
            dt.Rows.Add("Retailer", StartDate.AddMonths(3), ConvertDateToNumericOADate(StartDate.AddMonths(3)), 7.41, 28275);
            dt.Rows.Add("Retailer", StartDate.AddMonths(4), ConvertDateToNumericOADate(StartDate.AddMonths(4)), 7.67, 15960);
            dt.Rows.Add("Retailer", StartDate.AddMonths(5), ConvertDateToNumericOADate(StartDate.AddMonths(5)), 7.02, 11265);
            dt.Rows.Add("Retailer", StartDate.AddMonths(6), ConvertDateToNumericOADate(StartDate.AddMonths(6)), 5.96, 75000);
            dt.Rows.Add("Retailer", StartDate.AddMonths(7), ConvertDateToNumericOADate(StartDate.AddMonths(7)), 2.33, 90000);
            dt.Rows.Add("Retailer", StartDate.AddMonths(8), ConvertDateToNumericOADate(StartDate.AddMonths(8)), 1.58, 33000);
            dt.Rows.Add("Retailer", StartDate.AddMonths(9), ConvertDateToNumericOADate(StartDate.AddMonths(9)), 6.50, 2500);

            ultraChart1.DataSource = dt;

            this.ultraChart1.ChartType = ChartType.Composite;
            ChartArea area = new ChartArea();
            this.ultraChart1.CompositeChart.ChartAreas.Add(area);

            // Set up an custom IRenderLabel function...
            System.Collections.Hashtable labelHash = new System.Collections.Hashtable();
            labelHash.Add("OADATETODATESTRING", new MyLabelRendererOADateToDateString());
            ultraChart1.LabelHash = labelHash;
            ultraChart1.Axis.X.Labels.ItemFormatString = "<OADATETODATESTRING>";

            // Price axis
            AxisItem axisY = new AxisItem();
            axisY.Extent = 40;
            axisY.DataType = AxisDataType.Numeric;
            axisY.Labels.ItemFormat = AxisItemLabelFormat.Custom;
            axisY.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axisY.OrientationType = AxisNumber.Y_Axis;
            axisY.LineColor = Color.Black;
            axisY.RangeType = AxisRangeType.Automatic;
            //axisY.RangeMin = 0;
            //axisY.RangeMax = 60;
            area.Axes.Add(axisY);

            //Create X axis - for Numeric Date values
            AxisItem axisX = new AxisItem();
            axisX.DataType = AxisDataType.Numeric;
            axisX.Extent = 150;
            axisX.Labels.ItemFormat = AxisItemLabelFormat.DataValue;
            axisX.OrientationType = AxisNumber.X_Axis;
            axisX.SetLabelAxisType = SetLabelAxisType.ContinuousData;
            axisX.Labels.Orientation = TextOrientation.Custom;
            axisX.Labels.OrientationAngle = 45;
            axisX.Labels.HorizontalAlign = StringAlignment.Far;
            axisX.Labels.VerticalAlign = StringAlignment.Near;
            axisX.NumericAxisType = NumericAxisType.Linear;
            axisX.Labels.ItemFormat = AxisItemLabelFormat.Custom;
            axisX.Labels.ItemFormatString = "<OADATETODATESTRING:MM/dd/yyyy>";
            axisX.RangeType = AxisRangeType.Custom;
            axisX.RangeMin = StartDate.AddMonths(-1).ToOADate();   // to start 1 month before the data
            axisX.RangeMax = StartDate.AddMonths(10).ToOADate();   // to end 1 month after the data
            axisX.TickmarkInterval = 30;
            axisX.TickmarkStyle = AxisTickStyle.Smart;
            area.Axes.Add(axisX);

            //BubbleLayer
            ChartLayerAppearance BubbleLayer = new ChartLayerAppearance();
            BubbleLayer.Key = "Bubble";
            BubbleLayer.ChartType = ChartType.BubbleChart;
            BubbleLayer.ChartArea = area;

            //LegendLayer
            ChartLayerAppearance LegendLayer = new ChartLayerAppearance();
            LegendLayer.Key = "Legend";
            LegendLayer.ChartType = ChartType.ScatterChart;
            LegendLayer.ChartArea = area;

            // Bubble Series
            XYZSeries s1 = new XYZSeries();
            s1.Label = "test";
            s1.DataBind(dt, "DateAsOADateX", "PriceY", "SalesR", "ItemLabel");
            s1.PEs.Add(new PaintElement(Color.SteelBlue));
            BubbleLayer.Series.Add(s1);
            LegendLayer.Series.Add(s1);
            ultraChart1.CompositeChart.Series.Add(s1);
            BubbleLayer.AxisX = axisX;
            BubbleLayer.AxisY = axisY;
            this.ultraChart1.CompositeChart.ChartLayers.Add(BubbleLayer);

            // CompositeLegend
            //CompositeLegend myLegend = new CompositeLegend();
            //myLegend.ChartLayers.Add(LegendLayer);

            //myLegend.ChartLayers[0].LegendItem = LegendItemType.Point;
            //myLegend.Bounds = new Rectangle(10, 3, 25, 15);
            //myLegend.BoundsMeasureType = MeasureType.Percentage;
            //myLegend.PE.ElementType = PaintElementType.Gradient;
            //myLegend.PE.FillGradientStyle = GradientStyle.ForwardDiagonal;
            //myLegend.PE.Fill = Color.CornflowerBlue;
            //myLegend.PE.FillStopColor = Color.Transparent;
            //myLegend.Border.CornerRadius = 10;
            //myLegend.Border.Thickness = 1;

            // ultraChart1.Tooltips.Format = TooltipStyle.LabelPlusDataValue;
            //this.ultraChart1.CompositeChart.Legends.Add(myLegend);
            ultraChart1.Legend.Visible = true;

            ultraChart1.Tooltips.Format = Infragistics.UltraChart.Shared.Styles.TooltipStyle.None;
            ultraChart1.DataItemOver += new Infragistics.UltraChart.Shared.Events.DataItemOverEventHandler(ultraChart1_DataItemOver);
            ultraChart1.DataItemOut += new Infragistics.UltraChart.Shared.Events.DataItemOutEventHandler(ultraChart1_DataItemOut);
 
 
        }

        void ultraChart1_DataItemOut(object sender, Infragistics.UltraChart.Shared.Events.ChartDataEventArgs e)
        {
            ultraToolTipManager1.HideToolTip();
        }

        void ultraChart1_DataItemOver(object sender, Infragistics.UltraChart.Shared.Events.ChartDataEventArgs e)
        {

            if (e.LayerID != "Bubble")
            {
                tt.ToolTipText = "Column Label: " + e.ColumnLabel + "\n" + "Row Label: " + e.RowLabel + "\n" + "Value: " + e.DataValue.ToString();
                ultraToolTipManager1.SetUltraToolTip(ultraChart1, tt);
                ultraToolTipManager1.ShowToolTip(ultraChart1);
            }
            else
            {
                tt.ToolTipText = "Column Label: " + e.ColumnLabel + "\n" + "Row Label: " + e.RowLabel + "\n" + "Value: " + e.DataValue.ToString() + "\n" + "Date: " + dt.Rows[e.DataRow][1].ToString() + "\n" + "Date: " + dt.Rows[e.DataRow][2].ToString();
                ultraToolTipManager1.SetUltraToolTip(ultraChart1, tt);
                ultraToolTipManager1.ShowToolTip(ultraChart1);
            }
           
            
        }

        private static double ConvertDateToNumericOADate(DateTime date)
        {
            return date.ToOADate();
        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            List<Ellipse> listEllipse = new List<Ellipse>();
            foreach (Primitive item in e.SceneGraph)
            {
                Ellipse pl = item as Ellipse;
                if (pl != null && pl.Series != null) listEllipse.Add(pl);

                PointSet Points = item as PointSet;
                if (Points != null)
                {
                    int k = 0;
                    foreach (DataPoint pp in Points.points)
                    {
                        if (listEllipse.Count > k)
                        {
                            pp.point.X = (listEllipse[k].p1.X + listEllipse[k].p2.X / 2);
                            pp.point.Y = (listEllipse[k].p1.Y + listEllipse[k].p2.Y / 2);
                        }
                        k++;
                    }

                }
            }

            foreach (Primitive pr in e.SceneGraph)
            {
                if (pr.GetType() == typeof(PointSet))
                {
                    pr.Visible = false;
                }
            }
        }

    }
}

//---------------------------------------------------------------------------------------------------
// Reformats the xAxis label, converts it back to Date and formats it with the given format string.
//---------------------------------------------------------------------------------------------------
public class MyLabelRendererOADateToDateString : Infragistics.UltraChart.Resources.IRenderLabel
{
    public string ToString(System.Collections.Hashtable context)
    {
        DateTime dt;
        double labelValue = (double)context["DATA_VALUE"];
        string formatter = (string)context["RENDER_FORMAT"];
        dt = DateTime.FromOADate(labelValue);
        return string.Format("{0:" + formatter + "}", dt);
    }
}